#!/usr/bin/perl

# Webadmin CGI configuration
use CGI;
## Config Parameter ######################################

require "config.pl";

## Global Variable #######################################

@global_error_log;
@global_warning_log;
%pairs;

## Main Program ##########################################

$query = new CGI;

	# Get webpage parameter
	&get_parameter;

	# Check for some errors
	&check_all_errors;

	#Create new config file
	if(@global_error_log == 0){
		&open_file;
			&append_file("\# This file Created by Easy-Mon WebAdmin\n");
			$now_time = localtime;
			&append_file("\# $now_time\n\n");
			
			&append_file("\# UPS Characteristic\n");
				&process_UPS_DEVICE;
				&process_WALLPATH;
				&process_BACKUPTIME;
				&process_UPS_SHUTDOWN_DELAY;
				&process_TURNOFF_UPS;
			&append_file("\n\# Monitoring Configuration\n");
				&process_MAX_CLIENT;
				&process_PORT;
			&append_file("\n\# Alert Configuration\n");
				&process_POWERFAIL_ALERT;
				&process_POWERRETURN_ALERT;
				&process_LOWBATT_ALERT;
				&process_POWERFAIL_DOWN_ALERT;
				&process_SCHEDULE_DOWN_ALERT;
				&process_OVERLOAD_ALERT;
				&process_COMM_ERROR_ALERT;
				&process_COMM_CONNECT_ALERT;
			&append_file("\n\# PAGER Configuration\n");
				&process_MODEM_DEVICE;
				&process_POWERFAIL_PAGER;
				&process_POWERRETURN_PAGER;
				&process_LOWBATT_PAGER;
				&process_POWERFAIL_DOWN_PAGER;
				&process_SCHEDULE_DOWN_PAGER;
				&process_OVERLOAD_PAGER;
				&process_COMM_ERROR_PAGER;
				&process_COMM_CONNECT_PAGER;
			&append_file("\n\# Log Configuration\n");
				&process_POWERFAIL_LOG;
				&process_POWERRETURN_LOG;
				&process_LOWBATT_LOG;
				&process_POWERFAIL_DOWN_LOG;
				&process_SCHEDULE_DOWN_LOG;
				&process_OVERLOAD_LOG;
				&process_COMM_ERROR_LOG;
				&process_COMM_CONNECT_LOG;
				&process_LOGSIZE;
			&append_file("\n\# UPS testing schedule\n");
				&process_UPSTEST;
			&append_file("\n\# UPS shutdown schedule\n");
				&process_SHUTDOWN;
		&close_file;
		if(@global_warning_log == 0){
			&save_successful;
		} else{
			&show_warning_only;
		  }
	} else{
		&show_error_page;
	  }

#######################################################################################
#							   Utilities sub-routine								  #
#######################################################################################

sub get_parameter{
	my @names = $query->param;
	foreach $key (@names){
		print "$key : $query->param($key)\n";
		$pairs{$key} = $query->param($key);
	}
}

sub isEmpty{
	my $temp = @_[0];
	if($temp =~/^[ ]*$/){
		return(1);
	} else{
		return(0);
	}
}

sub isNumber{
	my $temp = @_[0];
	if($temp=~/^[0-9]*$/){
		return(1);
	} else{
		return(0);
	}
}

sub isValidTime{
	my $hour = @_[0];
	my $min = @_[1];
	if((not &isNumber($hour)) || (not &isNumber($min))){
		return(0);
	}
	if($hour ne ""){
		if(not ($hour >= 0 && $hour <= 23)){
			return(0);
		}
	}
	if($min ne ""){
		if(not ($min >= 0 && $min <= 59)){
			return(0);
		}
	}
	return(1);
}

#######################################################################################
#							  Error checking sub-routine							  #
#######################################################################################


sub check_all_errors{
	&BACKUPTIME_check;
	&UPS_SHUTDOWN_DELAY_check;
	&MAX_CLIENT_check;
	&PORT_check;
	&POWERFAIL_ALERT_check;
	&POWERRETURN_ALERT_check;
	&LOWBATT_check;
	&POWERFAIL_DOWN_ALERT_check;
	&SCHEDULE_DOWN_ALERT_check;
	&OVERLOAD_ALERT_check;
	&COMM_ERROR_ALERT_check;
	&COMM_CONNECT_ALERT_check;
	&LOG_SIZE_check;
	&SHUTDOWN_check;
}

sub BACKUPTIME_check{
	if(isNumber($pairs{'BACKUPTIME'}) == 0){
		&write_error_log("BACKUP_TIME should be a number");
	}
}

sub UPS_SHUTDOWN_DELAY_check{
	if(isNumber($pairs{'UPS_SHUTDOWN_DELAY'}) == 0){
		&write_error_log("UPS_SHUTDOWN_DELAY should be a number");
	}
}

sub MAX_CLIENT_check{
	if(isNumber($pairs{'MAX_CLIENT'}) == 0){
		&write_error_log("UPS_SHUTDOWN_DELAY should be a number");
	}
}

sub PORT_check{
	if(isNumber($pairs{'PORT'}) == 0){
		&write_error_log("PORT number should be a number");
	}
}

sub POWERFAIL_ALERT_check{
	if(isNumber($pairs{'POWERFAIL_ALERT_INT'}) == 0){
		&write_error_log("POWER_FAIL_ALERT Interval should be a number");
	}
}

sub POWERRETURN_ALERT_check{
	if(isNumber($pairs{'POWERRETURN_ALERT_INT'}) == 0){
		&write_error_log("POWER_RETURN Interval should be a number");
	}
}

sub LOWBATT_check{
	if(isNumber($pairs{'POWERRETURN_ALERT_INT'}) == 0){
		&write_error_log("POWER_RETURN Interval should be a number");
	}
}

sub POWERFAIL_DOWN_ALERT_check{
	if(isNumber($pairs{'POWERFAIL_DOWN_ALERT_INT'}) == 0){
		&write_error_log("POWERFAIL_DOWN_ALERT Interval should be a number");
	}
}

sub SCHEDULE_DOWN_ALERT_check{
	if(isNumber($pairs{'SCHEDULE_DOWN_ALERT_INT'}) == 0){
		&write_error_log("SCHEDULE_DOWN_ALERT Interval should be a number");
	}
}

sub OVERLOAD_ALERT_check{
	if(isNumber($pairs{'OVERLOAD_ALERT_INT'}) == 0){
		&write_error_log("OVERLOAD_ALERT Interval should be a number");
	}
}

sub COMM_ERROR_ALERT_check{
	if(isNumber($pairs{'COMM_ERROR_ALERT_INT'}) == 0){
		&write_error_log("COMM_ERROR_ALERT Interval should be a number");
	}
}

sub COMM_CONNECT_ALERT_check{
	if(isNumber($pairs{'COMM_CONNECT_ALERT_INT'}) == 0){
		&write_error_log("COMM_CONNECT_ALERT Interval should be a number");
	}
}

sub LOG_SIZE_check{
	if(isNumber($pairs{'LOGSIZE'}) == 0){
		&write_error_log("LOGSIZE should be a number");
	}
}

sub SHUTDOWN_check{
	my $allValid = 1;

	if(not isValidTime($pairs{'SHUTDOWN_WEEKLY_FROM_HOUR'},$pairs{'SHUTDOWN_WEEKLY_FROM_MIN'})){$allValid = 0;}
	if(not isValidTime($pairs{'SHUTDOWN_WEEKLY_TO_HOUR'},$pairs{'SHUTDOWN_WEEKLY_TO_MIN'})){$allValid = 0;}
	if(not isValidTime($pairs{'DAILY1_FROM_HOUR'},$pairs{'DAILY1_FROM_MIN'})){$allValid = 0;}
	if(not isValidTime($pairs{'DAILY1_TO_HOUR'},$pairs{'DAILY1_TO_MIN'})){$allValid = 0;}
	if(not isValidTime($pairs{'DAILY2_FROM_HOUR'},$pairs{'DAILY2_FROM_MIN'})){$allValid = 0;}
	if(not isValidTime($pairs{'DAILY2_TO_HOUR'},$pairs{'DAILY2_TO_MIN'})){$allValid = 0;}

	if($allValid == 0){
		&write_error_log("Time in SHUTDOWN_SCHEDULE is not valid.");
	}
}

#######################################################################################
#				    Confuguration file manipulation sub-routine						  #
#######################################################################################

sub open_file{
	open(CONF_FILE,">$conf_file_path$conf_file_name");
}

sub append_file{
	my $line = @_[0];
	print CONF_FILE "$line";
}

sub close_file{
	close(CONF_FILE);
}

sub process_UPS_DEVICE{
	$option_name = 'UPS_DEVICE';
	my $temp = $pairs{$option_name};
	&append_file("$option_name \"$temp\"\n");
}

sub process_WALLPATH{
	$option_name = 'WALLPATH';
	my $temp = $pairs{$option_name};
	&append_file("$option_name \"$temp\"\n");
}

sub process_BACKUPTIME{
	$option_name = 'BACKUPTIME';
	my $temp = $pairs{$option_name};
	&append_file("$option_name $temp\n");
}

sub process_UPS_SHUTDOWN_DELAY{
	$option_name = 'UPS_SHUTDOWN_DELAY';
	my $temp = $pairs{$option_name};
	&append_file("$option_name $temp\n");
}

sub process_TURNOFF_UPS{
	$option_name = 'TURNOFF_UPS';
	my $temp = $pairs{$option_name};
	&append_file("$option_name $temp\n");
}

sub process_MAX_CLIENT{
	$option_name = 'MAX_CLIENT';
	my $temp = $pairs{$option_name};
	&append_file("$option_name $temp\n");
}

sub process_PORT{
	$option_name = 'PORT';
	my $temp = $pairs{$option_name};
	&append_file("$option_name $temp\n");
}

sub process_POWERFAIL_ALERT{	
	$option_name = 'POWERFAIL_ALERT';
	my $temp = $pairs{$option_name.'_INT'};
	my $temp2 = $pairs{$option_name.'_AT'};
	my $temp3 = $pairs{$option_name.'_MSG'};
	&append_file("$option_name $temp $temp2 \"$temp3\"\n");
}

sub process_POWERRETURN_ALERT{
	$option_name = 'POWERRETURN_ALERT';
	my $temp = $pairs{$option_name.'_INT'};
	my $temp2 = $pairs{$option_name.'_AT'};
	my $temp3 = $pairs{$option_name.'_MSG'};
	&append_file("$option_name $temp $temp2 \"$temp3\"\n");}

sub process_LOWBATT_ALERT{
	$option_name = 'LOWBATT_ALERT';
	my $temp = $pairs{$option_name.'_INT'};
	my $temp2 = $pairs{$option_name.'_AT'};
	my $temp3 = $pairs{$option_name.'_MSG'};
	&append_file("$option_name $temp $temp2 \"$temp3\"\n");}

sub process_POWERFAIL_DOWN_ALERT{
	$option_name = 'POWERFAIL_DOWN_ALERT';
	my $temp = $pairs{$option_name.'_INT'};
	my $temp2 = $pairs{$option_name.'_AT'};
	my $temp3 = $pairs{$option_name.'_MSG'};
	&append_file("$option_name $temp $temp2 \"$temp3\"\n");}

sub process_SCHEDULE_DOWN_ALERT{
	$option_name = 'SCHEDULE_DOWN_ALERT';
	my $temp = $pairs{$option_name.'_INT'};
	my $temp2 = $pairs{$option_name.'_AT'};
	my $temp3 = $pairs{$option_name.'_MSG'};
	&append_file("$option_name $temp $temp2 \"$temp3\"\n");}

sub process_OVERLOAD_ALERT{
	$option_name = 'OVERLOAD_ALERT';
	my $temp = $pairs{$option_name.'_INT'};
	my $temp2 = $pairs{$option_name.'_AT'};
	my $temp3 = $pairs{$option_name.'_MSG'};
	&append_file("$option_name $temp $temp2 \"$temp3\"\n");}

sub process_COMM_ERROR_ALERT{
	$option_name = 'COMM_ERROR_ALERT';
	my $temp = $pairs{$option_name.'_INT'};
	my $temp2 = $pairs{$option_name.'_AT'};
	my $temp3 = $pairs{$option_name.'_MSG'};
	&append_file("$option_name $temp $temp2 \"$temp3\"\n");
}

sub process_COMM_CONNECT_ALERT{
	$option_name = 'COMM_CONNECT_ALERT';
	my $temp = $pairs{$option_name.'_INT'};
	my $temp2 = $pairs{$option_name.'_AT'};
	my $temp3 = $pairs{$option_name.'_MSG'};
	&append_file("$option_name $temp $temp2 \"$temp3\"\n");}

sub process_MODEM_DEVICE{
	$option_name = 'MODEM_DEVICE';
	my $temp = $pairs{$option_name};
	&append_file("$option_name $temp\n");
}

sub process_POWERFAIL_PAGER{
	$option_name = 'POWERFAIL_PAGER';
	my $temp = $pairs{$option_name};
	my $temp2 = $pairs{$option_name.'_COMMAND'};
	&append_file("$option_name $temp $temp2\n");
}

sub process_POWERRETURN_PAGER{
	$option_name = 'POWERRETURN_PAGER';
	my $temp = $pairs{$option_name};
	my $temp2 = $pairs{$option_name.'_COMMAND'};
	&append_file("$option_name $temp $temp2\n");
}

sub process_LOWBATT_PAGER{
	$option_name = 'LOWBATT_PAGER';
	my $temp = $pairs{$option_name};
	my $temp2 = $pairs{$option_name.'_COMMAND'};
	&append_file("$option_name $temp $temp2\n");
}

sub process_POWERFAIL_DOWN_PAGER{
	$option_name = 'POWERFAIL_DOWN_PAGER';
	my $temp2 = $pairs{$option_name.'_COMMAND'};
	my $temp = $pairs{$option_name};
	&append_file("$option_name $temp $temp2\n");
}

sub process_SCHEDULE_DOWN_PAGER{
	$option_name = 'SCHEDULE_DOWN_PAGER';
	my $temp2 = $pairs{$option_name.'_COMMAND'};
	my $temp = $pairs{$option_name};
	&append_file("$option_name $temp $temp2\n");
}

sub process_OVERLOAD_PAGER{
	$option_name = 'OVERLOAD_PAGER';
	my $temp2 = $pairs{$option_name.'_COMMAND'};
	my $temp = $pairs{$option_name};
	&append_file("$option_name $temp $temp2\n");
}

sub process_COMM_ERROR_PAGER{
	$option_name = 'COMM_ERROR_PAGER';
	my $temp = $pairs{$option_name};
	my $temp2 = $pairs{$option_name.'_COMMAND'};
	&append_file("$option_name $temp $temp2\n");
}

sub process_COMM_CONNECT_PAGER{
	$option_name = 'COMM_CONNECT_PAGER';
	my $temp = $pairs{$option_name};
	my $temp2 = $pairs{$option_name.'_COMMAND'};
	&append_file("$option_name $temp $temp2\n");
}

sub process_POWERFAIL_LOG{
	$option_name = 'POWERFAIL_LOG';
	my $temp = $pairs{$option_name};
	&append_file("$option_name $temp\n");
}

sub process_POWERRETURN_LOG{
	$option_name = 'POWERRETURN_LOG';
	my $temp = $pairs{$option_name};
	&append_file("$option_name $temp\n");
}

sub process_LOWBATT_LOG{
	$option_name = 'LOWBATT_LOG';
	my $temp = $pairs{$option_name};
	&append_file("$option_name $temp\n");
}

sub process_POWERFAIL_DOWN_LOG{
	$option_name = 'POWERFAIL_DOWN_LOG';
	my $temp = $pairs{$option_name};
	&append_file("$option_name $temp\n");
}

sub process_SCHEDULE_DOWN_LOG{
	$option_name = 'SCHEDULE_DOWN_LOG';
	my $temp = $pairs{$option_name};
	&append_file("$option_name $temp\n");
}

sub process_OVERLOAD_LOG{
	$option_name = 'OVERLOAD_LOG';
	my $temp = $pairs{$option_name};
	&append_file("$option_name $temp\n");
}

sub process_COMM_ERROR_LOG{
	$option_name = 'COMM_ERROR_LOG';
	my $temp = $pairs{$option_name};
	&append_file("$option_name $temp\n");
}

sub process_COMM_CONNECT_LOG{
	$option_name = 'COMM_CONNECT_LOG';
	my $temp = $pairs{$option_name};
	&append_file("$option_name $temp\n");
}

sub process_LOGSIZE{
	$option_name = 'LOGSIZE';
	my $temp = $pairs{$option_name};
	&append_file("$option_name $temp\n");
}

sub process_UPSTEST{
	open(TEST_FI,"$conf_file_path$conf_file_name".".test");
	$line = <TEST_FI>;
	close(TEST_FI);
	chomp($line);
	$line =~ s/\\/\\\n/g;
	if($line ne ""){
		&append_file("$line\n");
	} else{
		&append_file("UPSTEST \n");
	}
}

sub process_SHUTDOWN{
	my $temp = $pairs{'SHUTDOWN_SCHEDULE_TYPE'};
	if($temp=~/NONE/i){
		&append_file("SHUTDOWN \n");
	}elsif($temp=~/WEEKLY/i){
		my $from_day = $pairs{'SHUTDOWN_WEEKLY_FROM_DAY'};
		my $from_hour = $pairs{'SHUTDOWN_WEEKLY_FROM_HOUR'}; if($from_hour eq ""){$from_hour = "00"};
		my $from_min = $pairs{'SHUTDOWN_WEEKLY_FROM_MIN'}; if($from_min eq ""){$from_min = "00"};
		my $to_day = $pairs{'SHUTDOWN_WEEKLY_TO_DAY'}; 
		my $to_hour = $pairs{'SHUTDOWN_WEEKLY_TO_HOUR'}; if($to_hour eq ""){$to_hour = "00"};
		my $to_min = $pairs{'SHUTDOWN_WEEKLY_TO_MIN'}; if($to_min eq ""){$to_min = "00"};
		&append_file("SHUTDOWN WEEKLY $from_hour:$from_min#$from_day to $to_hour:$to_min#$to_day\n");
	}elsif($temp=~/DAILY1/i){
		my $from_hour = $pairs{'DAILY1_FROM_HOUR'}; if($from_hour eq ""){$from_hour = "00"};
		my $from_min = $pairs{'DAILY1_FROM_MIN'}; if($from_min eq ""){$from_min = "00"};
		my $to_hour = $pairs{'DAILY1_TO_HOUR'}; if($to_hour eq ""){$to_hour = "00"};
		my $to_min = $pairs{'DAILY1_TO_MIN'}; if($to_min eq ""){$to_min = "00"};
		&append_file("SHUTDOWN DAILY $from_hour:$from_min to $to_hour:$to_min\n");
	}elsif($temp=~/DAILY2/i){
		my $from_hour = $pairs{'DAILY2_FROM_HOUR'}; if($from_hour eq ""){$from_hour = "00"};
		my $from_min = $pairs{'DAILY2_FROM_MIN'}; if($from_min eq ""){$from_min = "00"};
		my $to_hour = $pairs{'DAILY2_TO_HOUR'}; if($to_hour eq ""){$to_hour = "00"};
		my $to_min = $pairs{'DAILY2_TO_MIN'}; if($to_min eq ""){$to_min = "00"};
		my $on_day = $pairs{'DAILY2_ON_DAY'};
		my $to_day = $pairs{'DAILY2_TO_DAY'};
		&append_file("SHUTDOWN DAILY $from_hour:$from_min to $to_hour:$to_min on $on_day to $to_day\n");
	}elsif($temp=~/MANUAL/i){
		open(DOWN_FI,"$conf_file_path$conf_file_name".".down");
		$line = <DOWN_FI>;
		close(DOWN_FI);
		chomp($line);
		$line =~ s/\\/\\\n/g;
		if($line ne ""){
			&append_file("$line\n");
		} else{
			&append_file("SHUTDOWN MANUAL \n");
		}
	}else{
	}
}

#######################################################################################
#						Error & Warning Management sub-routine						  #
#######################################################################################

sub write_error_log{
	my $temp = @_[0];
	push(@global_error_log,$temp);
}

sub write_warning_log{
	my $temp = @_[0];
	push(@global_warning_log,$temp);
}

sub show_error_page{
	print "Content-type:text/html\n\n";
	print "<html><header><title>There has some ERRORS!!!</title></header><body>";
	#print "<font size=7><b>There has some warning!</b></font><br>\n";
	#foreach $warning (@global_warning_log){
	#	print "<font color=red size=6>$warning</font><br>\n";
	#}
	print "<br><font size=7><b>There has some errors!</b></font><br>\n";
	foreach $error (@global_error_log){
		print "<font color=red size=6>&nbsp; - $error</font><br>\n";
	}
	print "Please press <a href=\"javascript:history.back()\">here</a> to go back and correct the errors.";
	print "</body></html>";
}

sub show_warning_only{
	print "Content-type:text/html\n\n";
	print "<html><header><title>There has some warnings</title></header><body>";
	print "<font size=7><b>There has some warning!</b></font><br>\n";
	foreach $warning (@global_warning_log){
		print "<font color=red size=6>$warning</font><br>\n";
	}
	print "These are just warning, your configuration had already saved.<br>\n";
	print "Click <a href=\"webadmin.pl\">here</a> to go back to configuration editor page<br>\n";
	print "</body></html>";
}

sub save_successful{
	$location = "webadmin.pl";
	print "Location: $location\n\n"; exit();
}
