#!/usr/bin/perl

# Webadmin CGI configuration

require "config.pl";

$editor_script = "editconfig.pl";

# Global Variable #################################################

%tokens;

# Main Program ####################################################
	use CGI;

	$cgi = new CGI;

	print $cgi->header;

	#Read config file and create tokens of each options
	%tokens = &create_token_list($conf_file_path,$conf_file_name);
	
	#Create some files as session object
	&create_file("$conf_file_path"."$conf_file_name".".test","UPSTEST ".$tokens{'UPSTEST'});
	@shutdown_attribute = &split_token_param($tokens{'SHUTDOWN'});
	if($shutdown_attribute[0] eq 'MANUAL'){
		&create_file("$conf_file_path"."$conf_file_name".".down","SHUTDOWN ".$tokens{'SHUTDOWN'});
	} else{
		&create_file("$conf_file_path"."$conf_file_name".".down","");
	  }

	#Generate HTML page
	&gen_page;

# Sub Routine Section #############################################

###################################################################
# Function: create_token_list									  #
# Description:													  #
#   This create_token_list() is used for create a list of Tokens. #
#   List of Tokens is in Associative Array that "key" is option's #
#   name and "value" is option's parameter.                       #
#																  #
# input:  (path_name,file_name)									  #
# output: associative array of tokens							  #
###################################################################
sub create_token_list{
	my @words;
	my $head;
	my @tail;
	my $temp;
	my %tokens_table;
	my $path_name = @_[0];
	my $file_name = @_[1];

	#open the config file;
	open(CONF_FILE,"$conf_file_path$conf_file_name");
	
	while(<CONF_FILE>){
		if( not /^[\n\t]*$/){
			if(not /^\#./){
				$temp = $_;
				while($_=~/\\[ ]*$/){
					$_ = <CONF_FILE>;
					$temp = $temp.$_;
				}
				#$temp=~s/\\/ /g;
				$temp=~s/\n//g;
				@words = split(/ /,$temp);
				($head,@tail) = @words;
				$before_add = join(' ',@tail);
				$tokens_table{$head} = $before_add;
			}	
		}
	}
	return(%tokens_table);
}

###################################################################
# Function: split_token_param									  #
# Description:													  #
#   This function is used for seperate one string of option's	  #
#   parameter to list of value and put each one into array.		  #
#																  #
# input:  (option_params) :option_params is parameter of option	  #
#			              :in one string.						  #
# output: an array of option's parameter value      			  #
###################################################################
sub split_token_param{
	my $value = @_[0];
	my @splited_value = split(/[ ]+/,$value);
	my @return_list;
	my $i=0;
	while($i<@splited_value){
		if($splited_value[$i] =~/$\"/){
			my $temp = $splited_value[$i];
			if(not $splited_value[$i] =~/\"$/){
				$i++;
				while(not $splited_value[$i] =~/\"$/){
					$temp = $temp." ".$splited_value[$i];
					$i++;
				}
				$temp = $temp." ".$splited_value[$i];
			}
			$temp=~s/\"//g;
			chomp($temp);
			push(@return_list,$temp);
		} else{
			chomp($splited_value[$i]);
			push(@return_list,$splited_value[$i]);
		  }
		$i++;
	}
	return(@return_list);
}

##################################################################
# Function: create_file											 #
# Description:													 #
#   This function is used for create new file and print the		 #
#   initial string into file.									 #
# Input: (file_name,initial_string)								 #
##################################################################
sub create_file{
	my $filename = @_[0];
	my $initial_text = @_[1];
	open(FI,">$filename");
	print FI "$initial_text\n";
	close(FI);
}

##################################################################
# Function: process_day										     #
# Description:													 #
#   This function is utility function that used for generate	 #
#   webadmin page.												 #
# Input: (string_day)											 #
##################################################################
sub process_day{
	my $input_day = @_[0];
	my @ret;
	if($input_day =~ /mon/i){ $ret[0] = "selected"; }
	if($input_day =~ /tue/i){ $ret[1] = "selected"; }
	if($input_day =~ /wed/i){ $ret[2] = "selected"; }
	if($input_day =~ /thu/i){ $ret[3] = "selected"; }
	if($input_day =~ /fri/i){ $ret[4] = "selected"; }
	if($input_day =~ /sat/i){ $ret[5] = "selected"; }
	if($input_day =~ /sun/i){ $ret[6] = "selected"; }

	return(@ret);
}

##################################################################
sub gen_page{
	print "<html>\n";
	print "<head>\n";
	print "<title>Easy-mon Web Admin</title>\n";
	print "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\n";
	print "</head>\n";
	print "\n";
	print "<body bgcolor=\"\#FFFFFF\" text=\"\#000000\">\n";
	print "<p align=\"left\"><font size=\"6\">Easy-mon Configuration</font><br>\n";
	print "</p>\n";
	print "<form name=\"config_info_collection\" method=\"post\" action=\"save_config.pl\">\n";
	print "<table width=\"738\" border=\"0\" bgcolor=\"\#000000\">\n";
	print "  <tr> \n";
	print "    <td colspan=\"2\" bgcolor=\"\#006699\"><font color=\"\#FFFFFF\"><b>UPS Characteristic</b></font></td>\n";
	print "  </tr>\n";
	print "  <tr bgcolor=\"\#FFFFCC\"> \n";
	print "    <td width=\"37\%\"><font color=\"\#000000\">&nbsp;&nbsp;UPS Device</font></td>\n";
	print "    <td width=\"63\%\"> \n";
	@temp = &split_token_param($tokens{'UPS_DEVICE'});
	print "      <input type=\"text\" name=\"UPS_DEVICE\" size=\"50\" value=\"$temp[0]\">\n";
	print "    </td>\n";
	print "  </tr>\n";
	print "  <tr bgcolor=\"\#FFFFCC\"> \n";
	print "    <td width=\"37\%\">&nbsp;&nbsp;Wall Path</td>\n";
	print "    <td width=\"63\%\"> \n";
	@temp = &split_token_param($tokens{'WALLPATH'});
	print "      <input type=\"text\" name=\"WALLPATH\" size=\"50\" value=\"$temp[0]\">\n";
	print "    </td>\n";
	print "  </tr>\n";
	print "  <tr bgcolor=\"\#FFFFCC\"> \n";
	print "    <td width=\"37\%\">&nbsp;&nbsp;Backup Time</td>\n";
	print "    <td width=\"63\%\"> \n";
	@temp = &split_token_param($tokens{'BACKUPTIME'});
	print "      <input type=\"text\" name=\"BACKUPTIME\" size=\"50\" value=\"$temp[0]\">\n";
	print "    </td>\n";
	print "  </tr>\n";
	print "  <tr bgcolor=\"\#FFFFCC\"> \n";
	print "    <td width=\"37\%\">&nbsp;&nbsp;UPS Shutdown delay</td>\n";
	print "    <td width=\"63\%\"> \n";
	@temp = &split_token_param($tokens{'UPS_SHUTDOWN_DELAY'});
	print "      <input type=\"text\" name=\"UPS_SHUTDOWN_DELAY\" size=\"50\" value=\"$temp[0]\">\n";
	print "    </td>\n";
	print "  </tr>\n";
	print "  <tr bgcolor=\"\#FFFFCC\"> \n";
	print "    <td width=\"37\%\">&nbsp;&nbsp;Turn off UPS</td>\n";
	print "    <td width=\"63\%\"> \n";
	@temp = &split_token_param($tokens{'TURNOFF_UPS'});
	if ($temp[0]=~/YES/i) {$yes = "checked";}
	if ($temp[0]=~/NO/i) {$no = "checked";}
	print "        <input type=\"radio\" name=\"TURNOFF_UPS\" value=\"YES\" $yes>\n";
	print "      Yes \n";
	print "        <input type=\"radio\" name=\"TURNOFF_UPS\" value=\"NO\" $no>\n";
	print "      No </td>\n";
	print "  </tr>\n";
	print "</table>\n";
	print "<br>\n";

	print "<table width=\"738\" border=\"0\" bgcolor=\"#000000\">";
	print "  <tr> ";
	print "    <td colspan=\"2\" bgcolor=\"#006699\"><font color=\"#FFFFFF\"><b>Monitoring Configuration</b></font></td>";
	print "  </tr>";
	print "  <tr bgcolor=\"#FFFFCC\"> ";
	print "    <td width=\"37%\"><font color=\"#000000\">&nbsp;&nbsp;Max Client</font></td>";
	print "    <td width=\"63%\"> ";
	@temp = &split_token_param($tokens{'MAX_CLIENT'});
	print "      <input type=\"text\" name=\"MAX_CLIENT\" size=\"10\" value=\"$temp[0]\">";
	print "    </td>";
	print " </tr>";
	print "  <tr bgcolor=\"#FFFFCC\"> ";
	print "    <td width=\"37%\">&nbsp;&nbsp;Port</td>";
	print "    <td width=\"63%\"> ";
	@temp = &split_token_param($tokens{'PORT'});
	print "      <input type=\"text\" name=\"PORT\" size=\"10\" value=\"$temp[0]\">";
	print "    </td>";
	print "  </tr>";
	print "</table>";
	print "<br>";

	print "<table width=\"738\" border=\"0\" bgcolor=\"\#000000\">\n";
	print "  <tr bgcolor=\"\#006699\"> \n";
	print "    <td colspan=\"4\"><b><font color=\"\#FFFFFF\">Alert Configuration</font></b></td>\n";
	print "  </tr>\n";
	print "  <tr bgcolor=\"\#FFFF99\"> \n";
	print "    <td width=\"37\%\">&nbsp;</td>\n";
	print "    <td width=\"8\%\"> \n";
	print "      <div align=\"center\">Interval</div>\n";
	print "    </td>\n";
	print "    <td width=\"14\%\"> \n";
	print "      <div align=\"center\">Alert At</div>\n";
	print "    </td>\n";
	print "    <td width=\"41\%\"> \n";
	print "      <div align=\"center\">Alert Message</div>\n";
	print "    </td>\n";
	print "  </tr>\n";
	print "  <tr bgcolor=\"\#FFFFCC\"> \n";
	print "    <td width=\"37\%\">Power Fail Alert</td>\n";
	print "    <td width=\"8\%\"> \n";
	print "      <div align=\"center\"> \n";
	@temp = &split_token_param($tokens{'POWERFAIL_ALERT'});
	print "        <input type=\"text\" name=\"POWERFAIL_ALERT_INT\" size=\"5\" value=$temp[0]>\n";
	print "      </div>\n";
	print "    </td>\n";
	print "    <td width=\"14\%\"> \n";
	print "      <div align=\"center\"> \n";
	print "        <select name=\"POWERFAIL_ALERT_AT\">\n";
	$all = ($temp[1]=~/all/i)?"selected":"";
	$none = ($temp[1]=~/none/i)?"selected":"";
	$console = ($temp[1]=~/console/i)?"selected":"";
	print "            <option value=\"All\" $all>All</option>\n";
	print "            <option value=\"None\" $none>None</option>\n";
	print "            <option value=\"Console\" $console>Console</option>\n";
	print "          </select>\n";
	print "      </div>\n";
	print "    </td>\n";
	print "    <td width=\"41\%\"> \n";
	print "      <div align=\"center\"> \n";
	print "        <input type=\"text\" name=\"POWERFAIL_ALERT_MSG\" size=\"50\" value=\"$temp[2]\">\n";
	print "      </div>\n";
	print "    </td>\n";
	print "  </tr>\n";
	print "  <tr bgcolor=\"\#FFFFCC\"> \n";
	print "    <td width=\"37\%\">Power Return Alert</td>\n";
	print "    <td width=\"8\%\"> \n";
	print "      <div align=\"center\"> \n";
	@temp = &split_token_param($tokens{'POWERRETURN_ALERT'});
	print "        <input type=\"text\" name=\"POWERRETURN_ALERT_INT\" size=\"5\" value=$temp[0]>\n";
	print "      </div>\n";
	print "    </td>\n";
	print "    <td width=\"14\%\"> \n";
	print "        <div align=\"center\"> \n";
	print "          <select name=\"POWERRETURN_ALERT_AT\">\n";
	$all = ($temp[1]=~/all/i)?"selected":"";
	$none = ($temp[1]=~/none/i)?"selected":"";
	$console = ($temp[1]=~/console/i)?"selected":"";
	print "            <option value=\"All\" $all>All</option>\n";
	print "            <option value=\"None\" $none>None</option $none>\n";
	print "            <option value=\"Console\" $console>Console</option $console>\n";
	print "          </select>\n";
	print "        </div>\n";
	print "    </td>\n";
	print "    <td width=\"41\%\"> \n";
	print "      <div align=\"center\"> \n";
	print "        <input type=\"text\" name=\"POWERRETURN_ALERT_MSG\" size=\"50\" value=\"$temp[2]\">\n";
	print "      </div>\n";
	print "    </td>\n";
	print "  </tr>\n";
	print "  <tr bgcolor=\"\#FFFFCC\"> \n";
	print "    <td width=\"37\%\">Low Battery Alert</td>\n";
	print "    <td width=\"8\%\"> \n";
	print "      <div align=\"center\"> \n";
	@temp = &split_token_param($tokens{'LOWBATT_ALERT'});
	print "        <input type=\"text\" name=\"LOWBATT_ALERT_INT\" size=\"5\" value=$temp[0]>\n";
	print "      </div>\n";
	print "    </td>\n";
	print "    <td width=\"14\%\"> \n";
	print "      <div align=\"center\"> \n";
	print "        <select name=\"LOWBATT_ALERT_AT\">\n";
	$all = ($temp[1]=~/all/i)?"selected":"";
	$none = ($temp[1]=~/none/i)?"selected":"";
	$console = ($temp[1]=~/console/i)?"selected":"";
	print "            <option value=\"All\" $all>All</option>\n";
	print "            <option value=\"None\" $none>None</option>\n";
	print "            <option value=\"Console\" $console>Console</option>\n";
	print "          </select>\n";
	print "      </div>\n";
	print "    </td>\n";
	print "    <td width=\"41\%\"> \n";
	print "      <div align=\"center\"> \n";
	print "        <input type=\"text\" name=\"LOWBATT_ALERT_MSG\" size=\"50\"8/11/2544 value=\"$temp[2]\">\n";
	print "      </div>\n";
	print "    </td>\n";
	print "  </tr>\n";
	print "  <tr bgcolor=\"\#FFFFCC\"> \n";
	print "    <td width=\"37\%\">Power Fail Alert (Shutdown Server)</td>\n";
	print "    <td width=\"8\%\"> \n";
	print "      <div align=\"center\"> \n";
	@temp = &split_token_param($tokens{'POWERFAIL_DOWN_ALERT'});
	print "        <input type=\"text\" name=\"POWERFAIL_DOWN_ALERT_INT\" size=\"5\" value=$temp[0]>\n";
	print "      </div>\n";
	print "    </td>\n";
	print "    <td width=\"14\%\"> \n";
	print "      <div align=\"center\"> \n";
	print "        <select name=\"POWERFAIL_DOWN_ALERT_AT\">\n";
	$all = ($temp[1]=~/all/i)?"selected":"";
	$none = ($temp[1]=~/none/i)?"selected":"";
	$console = ($temp[1]=~/console/i)?"selected":"";
	print "            <option value=\"All\" $all>All</option>\n";
	print "            <option value=\"None\" $none>None</option>\n";
	print "            <option value=\"Console\" $console>Console</option>\n";
	print "          </select>\n";
	print "      </div>\n";
	print "    </td>\n";
	print "    <td width=\"41\%\"> \n";
	print "      <div align=\"center\"> \n";
	print "        <input type=\"text\" name=\"POWERFAIL_DOWN_ALERT_MSG\" size=\"50\"  value=\"$temp[2]\">\n";
	print "      </div>\n";
	print "    </td>\n";
	print "  </tr>\n";
	print "  <tr bgcolor=\"\#FFFFCC\"> \n";
	print "    <td width=\"37\%\">Schedule Shutdown Alert</td>\n";
	print "    <td width=\"8\%\"> \n";
	print "      <div align=\"center\"> \n";
	@temp = &split_token_param($tokens{'SCHEDULE_DOWN_ALERT'});
	print "        <input type=\"text\" name=\"SCHEDULE_DOWN_ALERT_INT\" size=\"5\" value=$temp[0]>\n";
	print "      </div>\n";
	print "    </td>\n";
	print "    <td width=\"14\%\"> \n";
	print "      <div align=\"center\"> \n";
	print "        <select name=\"SCHEDULE_DOWN_ALERT_AT\">\n";
	$all = ($temp[1]=~/all/i)?"selected":"";
	$none = ($temp[1]=~/none/i)?"selected":"";
	$console = ($temp[1]=~/console/i)?"selected":"";
	print "            <option value=\"All\" $all>All</option>\n";
	print "            <option value=\"None\" $none>None</option>\n";
	print "            <option value=\"Console\" $console>Console</option>\n";
	print "          </select>\n";
	print "      </div>\n";
	print "    </td>\n";
	print "    <td width=\"41\%\"> \n";
	print "      <div align=\"center\"> \n";
	print "        <input type=\"text\" name=\"SCHEDULE_DOWN_ALERT_MSG\" size=\"50\" value=\"$temp[2]\">\n";
	print "      </div>\n";
	print "    </td>\n";
	print "  </tr>\n";
	print "  <tr bgcolor=\"\#FFFFCC\"> \n";
	print "    <td width=\"37\%\">Overload Alert</td>\n";
	print "    <td width=\"8\%\"> \n";
	print "      <div align=\"center\"> \n";
	@temp = &split_token_param($tokens{'OVERLOAD_ALERT'});
	print "        <input type=\"text\" name=\"OVERLOAD_ALERT_INT\" size=\"5\" value=$temp[0]>\n";
	print "      </div>\n";
	print "    </td>\n";
	print "    <td width=\"14\%\"> \n";
	print "      <div align=\"center\"> \n";
	print "        <select name=\"OVERLOAD_ALERT_AT\">\n";
	$all = ($temp[1]=~/all/i)?"selected":"";
	$none = ($temp[1]=~/none/i)?"selected":"";
	$console = ($temp[1]=~/console/i)?"selected":"";
	print "            <option value=\"All\" selected $all>All</option>\n";
	print "            <option value=\"None\" $none>None</option>\n";
	print "            <option value=\"Console\" $console>Console</option>\n";
	print "          </select>\n";
	print "      </div>\n";
	print "    </td>\n";
	print "    <td width=\"41\%\"> \n";
	print "      <div align=\"center\"> \n";
	print "        <input type=\"text\" name=\"OVERLOAD_ALERT_MSG\" size=\"50\"  value=\"$temp[2]\">\n";
	print "      </div>\n";
	print "    </td>\n";
	print "  </tr>\n";
	print "  <tr bgcolor=\"\#FFFFCC\"> \n";
	print "    <td width=\"37\%\">Error Communicate with UPS Alert</td>\n";
	print "    <td width=\"8\%\"> \n";
	print "      <div align=\"center\"> \n";
	@temp = &split_token_param($tokens{'COMM_ERROR_ALERT'});
	print "        <input type=\"text\" name=\"COMM_ERROR_ALERT_INT\" size=\"5\" value=$temp[0]>\n";
	print "      </div>\n";
	print "    </td>\n";
	print "    <td width=\"14\%\"> \n";
	print "      <div align=\"center\"> \n";
	print "        <select name=\"COMM_ERROR_ALERT_AT\">\n";
	$all = ($temp[1]=~/all/i)?"selected":"";
	$none = ($temp[1]=~/none/i)?"selected":"";
	$console = ($temp[1]=~/console/i)?"selected":"";
	print "            <option value=\"All\" $all>All</option>\n";
	print "            <option value=\"None\" $none>None</option>\n";
	print "            <option value=\"Console\" $console>Console</option>\n";
	print "          </select>\n";
	print "      </div>\n";
	print "    </td>\n";
	print "    <td width=\"41\%\"> \n";
	print "      <div align=\"center\"> \n";
	print "        <input type=\"text\" name=\"COMM_ERROR_ALERT_MSG\" size=\"50\" value=\"$temp[2]\">\n";
	print "      </div>\n";
	print "    </td>\n";
	print "  </tr>\n";
	print "  <tr bgcolor=\"\#FFFFCC\"> \n";
	print "    <td width=\"37\%\">Establish Connection with UPS Alert</td>\n";
	print "    <td width=\"8\%\"> \n";
	print "      <div align=\"center\"> \n";
	@temp = &split_token_param($tokens{'COMM_CONNECT_ALERT'});
	print "        <input type=\"text\" name=\"COMM_CONNECT_ALERT_INT\" size=\"5\" value=$temp[0]>\n";
	print "      </div>\n";
	print "    </td>\n";
	print "    <td width=\"14\%\"> \n";
	print "      <div align=\"center\"> \n";
	print "        <select name=\"COMM_CONNECT_ALERT_AT\">\n";
	$all = ($temp[1]=~/all/i)?"selected":"";
	$none = ($temp[1]=~/none/i)?"selected":"";
	$console = ($temp[1]=~/console/i)?"selected":"";
	print "            <option value=\"All\" $all>All</option>\n";
	print "            <option value=\"None\" $none>None</option>\n";
	print "            <option value=\"Console\" $console>Console</option>\n";
	print "          </select>\n";
	print "      </div>\n";
	print "    </td>\n";
	print "    <td width=\"41\%\"> \n";
	print "      <div align=\"center\"> \n";
	print "        <input type=\"text\" name=\"COMM_CONNECT_ALERT_MSG\" size=\"50\" value=\"$temp[2]\">\n";
	print "      </div>\n";
	print "    </td>\n";
	print "  </tr>\n";
	print "</table>\n";
	print "<br>\n";
	print "  <table width=\"738\" border=\"0\" bgcolor=\"\#000000\">\n";
	print "    <tr bgcolor=\"\#006699\"> \n";
	print "      <td colspan=\"3\"><b><font color=\"\#FFFFFF\">Pager Configuration</font></b></td>\n";
	print "    </tr>\n";
	print "    <tr bgcolor=\"\#FFFFCC\"> \n";
	print "      <td width=\"37\%\">Modem Device</td>\n";
	print "      <td colspan=\"2\"> \n";
	@temp = &split_token_param($tokens{'MODEM_DEVICE'});
	print "        <input type=\"text\" name=\"MODEM_DEVICE\" size=\"50\" value=\"$temp[0]\">\n";
	print "      </td>\n";
	print "    </tr>\n";
	print "    <tr bgcolor=\"\#FFFF99\"> \n";
	print "      <td width=\"37\%\">&nbsp;</td>\n";
	print "      <td width=\"17\%\"> \n";
	print "        <div align=\"center\">Switch</div>\n";
	print "      </td>\n";
	print "      <td width=\"46\%\"> \n";
	print "        <div align=\"center\">Modem Command</div>\n";
	print "      </td>\n";
	print "    </tr>\n";
	print "    <tr bgcolor=\"\#FFFFCC\"> \n";
	print "      <td width=\"37\%\">Power Fail Pager</td>\n";
	print "      <td width=\"17\%\"> \n";
	print "        <div align=\"center\"> \n";
	@temp = &split_token_param($tokens{'POWERFAIL_PAGER'});
	$yes = ($temp[0]=~/yes/i)?"checked":"";
	$no = ($temp[0]=~/no/i)?"checked":"";
	print "          <input type=\"radio\" name=\"POWERFAIL_PAGER\" value=\"YES\" $yes>\n";
	print "          Yes \n";
	print "          <input type=\"radio\" name=\"POWERFAIL_PAGER\" value=\"NO\" $no>\n";
	print "          No </div>\n";
	print "      </td>\n";
	print "      <td width=\"46\%\"> \n";
	print "        <div align=\"center\"> \n";
	print "          <input type=\"text\" name=\"POWERFAIL_PAGER_COMMAND\" size=\"50\" value=\"$temp[1]\">\n";
	print "        </div>\n";
	print "      </td>\n";
	print "    </tr>\n";
	print "    <tr bgcolor=\"\#FFFFCC\"> \n";
	print "      <td width=\"37\%\">Power Return Pager</td>\n";
	print "      <td width=\"17\%\"> \n";
	print "        <div align=\"center\"> \n";
	@temp = &split_token_param($tokens{'POWERRETURN_PAGER'});
	$yes = ($temp[0]=~/yes/i)?"checked":"";
	$no = ($temp[0]=~/no/i)?"checked":"";
	print "          <input type=\"radio\" name=\"POWERRETURN_PAGER\" value=\"YES\" $yes>\n";
	print "          Yes \n";
	print "          <input type=\"radio\" name=\"POWERRETURN_PAGER\" value=\"NO\" $no>\n";
	print "          No </div>\n";
	print "      </td>\n";
	print "      <td width=\"46\%\"> \n";
	print "        <div align=\"center\"> \n";
	print "          <input type=\"text\" name=\"POWERRETURN_PAGER_COMMAND\" size=\"50\" value=\"$temp[1]\">\n";
	print "        </div>\n";
	print "      </td>\n";
	print "    </tr>\n";
	print "    <tr bgcolor=\"\#FFFFCC\"> \n";
	print "      <td width=\"37\%\">Low Battery Pager</td>\n";
	print "      <td width=\"17\%\"> \n";
	print "        <div align=\"center\"> \n";
	@temp = &split_token_param($tokens{'LOWBATT_PAGER'});
	$yes = ($temp[0]=~/yes/i)?"checked":"";
	$no = ($temp[0]=~/no/i)?"checked":"";
	print "          <input type=\"radio\" name=\"LOWBATT_PAGER\" value=\"YES\" $yes>\n";
	print "          Yes \n";
	print "          <input type=\"radio\" name=\"LOWBATT_PAGER\" value=\"NO\" $no>\n";
	print "          No </div>\n";
	print "      </td>\n";
	print "      <td width=\"46\%\"> \n";
	print "        <div align=\"center\"> \n";
	print "          <input type=\"text\" name=\"LOWBATT_PAGER_COMMAND\" size=\"50\" value=\"$temp[1]\">\n";
	print "        </div>\n";
	print "      </td>\n";
	print "    </tr>\n";
	print "    <tr bgcolor=\"\#FFFFCC\"> \n";
	print "      <td width=\"37\%\">Power Fail (Shutdown Server) Pager</td>\n";
	print "      <td width=\"17\%\"> \n";
	print "        <div align=\"center\"> \n";
	@temp = &split_token_param($tokens{'POWERFAIL_DOWN_PAGER'});
	$yes = ($temp[0]=~/yes/i)?"checked":"";
	$no = ($temp[0]=~/no/i)?"checked":"";
	print "          <input type=\"radio\" name=\"POWERFAIL_DOWN_PAGER\" value=\"YES\" $yes>\n";
	print "          Yes \n";
	print "          <input type=\"radio\" name=\"POWERFAIL_DOWN_PAGER\" value=\"NO\" $no>\n";
	print "          No </div>\n";
	print "      </td>\n";
	print "      <td width=\"46\%\"> \n";
	print "        <div align=\"center\"> \n";
	print "          <input type=\"text\" name=\"POWERFAIL_DOWN_PAGER_COMMAND\" size=\"50\" value=\"$temp[1]\">\n";
	print "        </div>\n";
	print "      </td>\n";
	print "    </tr>\n";
	print "    <tr bgcolor=\"\#FFFFCC\"> \n";
	print "      <td width=\"37\%\">Schedule Shutdown Pager</td>\n";
	print "      <td width=\"17\%\"> \n";
	print "        <div align=\"center\"> \n";
	@temp = &split_token_param($tokens{'SCHEDULE_DOWN_PAGER'});
	$yes = ($temp[0]=~/yes/i)?"checked":"";
	$no = ($temp[0]=~/no/i)?"checked":"";
	print "          <input type=\"radio\" name=\"SCHEDULE_DOWN_PAGER\" value=\"YES\" $yes>\n";
	print "          Yes \n";
	print "          <input type=\"radio\" name=\"SCHEDULE_DOWN_PAGER\" value=\"NO\" $no>\n";
	print "          No </div>\n";
	print "      </td>\n";
	print "      <td width=\"46\%\"> \n";
	print "        <div align=\"center\"> \n";
	print "          <input type=\"text\" name=\"SCHEDULE_DOWN_PAGER_COMMAND\" size=\"50\" value=\"$temp[1]\">\n";
	print "        </div>\n";
	print "      </td>\n";
	print "    </tr>\n";
	print "    <tr bgcolor=\"\#FFFFCC\"> \n";
	print "      <td width=\"37\%\">Overload Pager</td>\n";
	print "      <td width=\"17\%\"> \n";
	print "        <div align=\"center\"> \n";
	@temp = &split_token_param($tokens{'OVERLOAD_PAGER'});
	$yes = ($temp[0]=~/yes/i)?"checked":"";
	$no = ($temp[0]=~/no/i)?"checked":"";
	print "          <input type=\"radio\" name=\"OVERLOAD_PAGER\" value=\"YES\" $yes>\n";
	print "          Yes \n";
	print "          <input type=\"radio\" name=\"OVERLOAD_PAGER\" value=\"NO\" $no>\n";
	print "          No </div>\n";
	print "      </td>\n";
	print "      <td width=\"46\%\"> \n";
	print "        <div align=\"center\"> \n";
	print "          <input type=\"text\" name=\"OVERLOAD_PAGER_COMMAND\" size=\"50\" value=\"$temp[1]\">\n";
	print "        </div>\n";
	print "      </td>\n";
	print "    </tr>\n";
	print "    <tr bgcolor=\"\#FFFFCC\"> \n";
	print "      <td width=\"37\%\">Error Communicate with UPS Pager</td>\n";
	print "      <td width=\"17\%\"> \n";
	print "        <div align=\"center\"> \n";
	@temp = &split_token_param($tokens{'COMM_ERROR_PAGER'});
	$yes = ($temp[0]=~/yes/i)?"checked":"";
	$no = ($temp[0]=~/no/i)?"checked":"";
	print "          <input type=\"radio\" name=\"COMM_ERROR_PAGER\" value=\"YES\" $yes>\n";
	print "          Yes \n";
	print "          <input type=\"radio\" name=\"COMM_ERROR_PAGER\" value=\"NO\" $no>\n";
	print "          No </div>\n";
	print "      </td>\n";
	print "      <td width=\"46\%\"> \n";
	print "        <div align=\"center\"> \n";
	print "          <input type=\"text\" name=\"COMM_ERROR_PAGER_COMMAND\" size=\"50\" value=\"$temp[1]\">\n";
	print "        </div>\n";
	print "      </td>\n";
	print "    </tr>\n";
	print "    <tr bgcolor=\"\#FFFFCC\"> \n";
	print "      <td width=\"37\%\">Establish Connection with UPS Pager</td>\n";
	print "      <td width=\"17\%\"> \n";
	print "        <div align=\"center\"> \n";
	@temp = &split_token_param($tokens{'COMM_CONNECT_PAGER'});
	$yes = ($temp[0]=~/yes/i)?"checked":"";
	$no = ($temp[0]=~/no/i)?"checked":"";
	print "          <input type=\"radio\" name=\"COMM_CONNECT_PAGER\" value=\"YES\" $yes>\n";
	print "          Yes \n";
	print "          <input type=\"radio\" name=\"COMM_CONNECT_PAGER\" value=\"NO\" $no>\n";
	print "          No </div>\n";
	print "      </td>\n";
	print "      <td width=\"46\%\"> \n";
	print "        <div align=\"center\"> \n";
	print "          <input type=\"text\" name=\"COMM_CONNECT_PAGER_COMMAND\" size=\"50\" value=\"$temp[1]\">\n";
	print "        </div>\n";
	print "      </td>\n";
	print "    </tr>\n";
	print "  </table>\n";
	print "<br>\n";
	print "<table width=\"738\" border=\"0\" bgcolor=\"\#000000\">\n";
	print "  <tr bgcolor=\"\#006699\"> \n";
	print "    <td colspan=\"2\"><b><font color=\"\#FFFFFF\">Log Configuration</font></b></td>\n";
	print "  </tr>\n";
	print "  <tr bgcolor=\"\#FFFFCC\"> \n";
	print "    <td width=\"37\%\">Power Fail Log</td>\n";
	print "    <td width=\"63\%\">\n";
	@temp = &split_token_param($tokens{'POWERFAIL_LOG'});
	$yes = ($temp[0]=~/yes/i)?"checked":"";
	$no = ($temp[0]=~/no/i)?"checked":"";
	print "        <input type=\"radio\" name=\"POWERFAIL_LOG\" value=\"YES\" $yes>\n";
	print "      Yes \n";
	print "        <input type=\"radio\" name=\"POWERFAIL_LOG\" value=\"NO\" $no>\n";
	print "      No </td>\n";
	print "  </tr>\n";
	print "  <tr bgcolor=\"\#FFFFCC\"> \n";
	print "    <td width=\"37\%\">Power Return Log</td>\n";
	print "    <td width=\"63\%\">\n";
	@temp = &split_token_param($tokens{'POWERRETURN_LOG'});
	$yes = ($temp[0]=~/yes/i)?"checked":"";
	$no = ($temp[0]=~/no/i)?"checked":"";
	print "        <input type=\"radio\" name=\"POWERRETURN_LOG\" value=\"YES\" $yes>\n";
	print "      Yes \n";
	print "        <input type=\"radio\" name=\"POWERRETURN_LOG\" value=\"NO\" $no>\n";
	print "      No </td>\n";
	print "  </tr>\n";
	print "  <tr bgcolor=\"\#FFFFCC\"> \n";
	print "    <td width=\"37\%\">Low Battery log</td>\n";
	print "    <td width=\"63\%\">\n";
	@temp = &split_token_param($tokens{'LOWBATT_LOG'});
	$yes = ($temp[0]=~/yes/i)?"checked":"";
	$no = ($temp[0]=~/no/i)?"checked":"";
	print "        <input type=\"radio\" name=\"LOWBATT_LOG\" value=\"YES\" $yes>\n";
	print "      Yes \n";
	print "        <input type=\"radio\" name=\"LOWBATT_LOG\" value=\"NO\" $no>\n";
	print "      No </td>\n";
	print "  </tr>\n";
	print "  <tr bgcolor=\"\#FFFFCC\"> \n";
	print "    <td width=\"37\%\">Power Fail (Shutdown Server) Log</td>\n";
	print "    <td width=\"63\%\">\n";
	@temp = &split_token_param($tokens{'POWERFAIL_DOWN_LOG'});
	$yes = ($temp[0]=~/yes/i)?"checked":"";
	$no = ($temp[0]=~/no/i)?"checked":"";
	print "        <input type=\"radio\" name=\"POWERFAIL_DOWN_LOG\" value=\"YES\" $yes>\n";
	print "      Yes \n";
	print "        <input type=\"radio\" name=\"POWERFAIL_DOWN_LOG\" value=\"NO\" $no>\n";
	print "      No </td>\n";
	print "  </tr>\n";
	print "  <tr bgcolor=\"\#FFFFCC\"> \n";
	print "    <td width=\"37\%\">Schedule Shotdown Log</td>\n";
	print "    <td width=\"63\%\">\n";
	@temp = &split_token_param($tokens{'SCHEDULE_DOWN_LOG'});
	$yes = ($temp[0]=~/yes/i)?"checked":"";
	$no = ($temp[0]=~/no/i)?"checked":"";
	print "        <input type=\"radio\" name=\"SCHEDULE_DOWN_LOG\" value=\"YES\" $yes>\n";
	print "      Yes \n";
	print "        <input type=\"radio\" name=\"SCHEDULE_DOWN_LOG\" value=\"NO\" $no>\n";
	print "      No </td>\n";
	print "  </tr>\n";
	print "  <tr bgcolor=\"\#FFFFCC\"> \n";
	print "    <td width=\"37\%\">Overload Log</td>\n";
	print "    <td width=\"63\%\">\n";
	@temp = &split_token_param($tokens{'OVERLOAD_LOG'});
	$yes = ($temp[0]=~/yes/i)?"checked":"";
	$no = ($temp[0]=~/no/i)?"checked":"";
	print "        <input type=\"radio\" name=\"OVERLOAD_LOG\" value=\"YES\" $yes>\n";
	print "      Yes \n";
	print "        <input type=\"radio\" name=\"OVERLOAD_LOG\" value=\"NO\" $no>\n";
	print "      No </td>\n";
	print "  </tr>\n";
	print "  <tr bgcolor=\"\#FFFFCC\"> \n";
	print "    <td width=\"37\%\">Error Communicate with UPS Log</td>\n";
	print "    <td width=\"63\%\">\n";
	@temp = &split_token_param($tokens{'COMM_ERROR_LOG'});
	$yes = ($temp[0]=~/yes/i)?"checked":"";
	$no = ($temp[0]=~/no/i)?"checked":"";
	print "        <input type=\"radio\" name=\"COMM_ERROR_LOG\" value=\"YES\" $yes>\n";
	print "      Yes \n";
	print "        <input type=\"radio\" name=\"COMM_ERROR_LOG\" value=\"NO\" $no>\n";
	print "      No </td>\n";
	print "  </tr>\n";
	print "  <tr bgcolor=\"\#FFFFCC\"> \n";
	print "    <td width=\"37\%\">Establish Connection with UPS Log</td>\n";
	print "    <td width=\"63\%\">\n";
	@temp = &split_token_param($tokens{'COMM_CONNECT_LOG'});
	$yes = ($temp[0]=~/yes/i)?"checked":"";
	$no = ($temp[0]=~/no/i)?"checked":"";
	print "        <input type=\"radio\" name=\"COMM_CONNECT_LOG\" value=\"YES\" $yes>\n";
	print "      Yes \n";
	print "        <input type=\"radio\" name=\"COMM_CONNECT_LOG\" value=\"NO\" $no>\n";
	print "      No </td>\n";
	print "  </tr>\n";
	print "  <tr bgcolor=\"\#FFFFCC\">\n";
	print "    <td width=\"37\%\">Log Size</td>\n";
	print "    <td width=\"63\%\"> \n";
	@temp = &split_token_param($tokens{'LOGSIZE'});
	print "      <input type=\"text\" name=\"LOGSIZE\" size=\"10\" value=\"$temp[0]\">\n";
	print "      Kb </td>\n";
	print "  </tr>\n";
	print "</table>\n";
	print "<br>\n";

	@temp = &split_token_param($tokens{'SHUTDOWN'});
	if($temp[0] eq "NONE"){
		$none = "checked";
	}elsif($temp[0] eq "WEEKLY"){
		$weekly = "checked";
		($w1_time,$w1_day) = split('#',$temp[1]);
		($w1_time_hour,$w1_time_min) = split(':',$w1_time);
		($w2_time,$w2_day) = split('#',$temp[3]);
		($w2_time_hour,$w2_time_min) = split(':',$w2_time);
	} 
	elsif($temp[0] eq "DAILY"){
		if($temp[4]=~/on/){
			$daily2 = "checked";
			$d21 = $temp[1];
			$d22 = $temp[3];
			($d21_hour,$d21_min) = split(':',$d21);
			($d22_hour,$d22_min) = split(':',$d22);
			$d2_day1 = $temp[5];
			$d2_day2 = $temp[7];
		} else{
			$daily1 = "checked";
			$d11 = $temp[1];
			$d12 = $temp[3];
			($d11_hour,$d11_min) = split(':',$d11);
			($d12_hour,$d12_min) = split(':',$d12);
		  }
	}
	elsif($temp[0] eq "MANUAL"){
		($left,@remain) = (@temp);
		$down_schedule = join(" ",@remain);
		$manual = "checked";
	} else {
		$down_schedule = "";
	  }
	@down_list = split(/\\/,$down_schedule);
	print "  <table width=\"738\" border=\"0\" bgcolor=\"\#000000\">\n";
	print "    <tr bgcolor=\"\#006699\"> \n";
	print "      <td colspan=\"3\"><b><font color=\"\#FFFFFF\">Shutdown Schedule</font></b></td>\n";
	print "    </tr>\n";
	print "    <tr bgcolor=\"\#FFFFCC\"> \n";
	print "      <td width=\"13\%\">";
	print "        <div align=\"left\"> \n";
	print "          <input type=\"radio\" name=\"SHUTDOWN_SCHEDULE_TYPE\" value=\"NONE\" $none>\n";
	print "          None</div>\n";
	print "      </td>\n";
	print "      <td colspan=2> \n";
	print "        <div align=\"center\">&nbsp;</div>\n";
	print "      </td>\n";
	print "	   </tr>";
	print "    <tr bgcolor=\"\#FFFF99\"> \n";
	print "      <td width=\"13\%\">&nbsp;</td>\n";
	print "      <td width=\"44\%\"> \n";
	print "        <div align=\"center\">From</div>\n";
	print "      </td>\n";
	print "      <td width=\"43\%\"> \n";
	print "        <div align=\"center\">To</div>\n";
	print "      </td>\n";
	print "    </tr>\n";
	print "    <tr bgcolor=\"\#FFFFCC\"> \n";
	print "      <td width=\"13\%\"> \n";
	print "        <div align=\"left\"> \n";
	print "          <input type=\"radio\" name=\"SHUTDOWN_SCHEDULE_TYPE\" value=\"WEEKLY\" $weekly>\n";
	print "          Weekly</div>\n";
	print "      </td>\n";
	print "      <td width=\"44\%\"> \n";
	print "        <div align=\"center\">Day \n";
	print "          <select name=\"SHUTDOWN_WEEKLY_FROM_DAY\">\n";
	@day_return = &process_day($w1_day);
	print "            <option value=\"MON\" $day_return[0] >Mon</option>\n";
	print "            <option value=\"TUE\" $day_return[1] >Tue</option>\n";
	print "            <option value=\"WED\" $day_return[2] >Wed</option>\n";
	print "            <option value=\"THU\" $day_return[3] >Thu</option>\n";
	print "            <option value=\"FRI\" $day_return[4] >Fri</option>\n";
	print "            <option value=\"SAT\" $day_return[5] >Sat</option>\n";
	print "            <option value=\"SUN\" $day_return[6] >Sun</option>\n";
	print "          </select>\n";
	print "          HH:MM \n";
	print "          <input type=\"text\" name=\"SHUTDOWN_WEEKLY_FROM_HOUR\" size=\"2\" maxlength=\"2\" value=$w1_time_hour>\n";
	print "          : \n";
	print "          <input type=\"text\" name=\"SHUTDOWN_WEEKLY_FROM_MIN\" size=\"2\" maxlength=\"2\" value=$w1_time_min>\n";
	print "        </div>\n";
	print "      </td>\n";
	print "      <td width=\"43\%\"> \n";
	print "        <div align=\"center\">Day \n";
	print "          <select name=\"SHUTDOWN_WEEKLY_TO_DAY\">\n";
	@day_return = &process_day($w2_day);
	print "            <option value=\"MON\" $day_return[0] >Mon</option>\n";
	print "            <option value=\"TUE\" $day_return[1] >Tue</option>\n";
	print "            <option value=\"WED\" $day_return[2] >Wed</option>\n";
	print "            <option value=\"THU\" $day_return[3] >Thu</option>\n";
	print "            <option value=\"FRI\" $day_return[4] >Fri</option>\n";
	print "            <option value=\"SAT\" $day_return[5] >Sat</option>\n";
	print "            <option value=\"SUN\" $day_return[6] >Sun</option>\n";
	print "          </select>\n";
	print "          HH:MM \n";
	print "          <input type=\"text\" name=\"SHUTDOWN_WEEKLY_TO_HOUR\" size=\"2\" maxlength=\"2\" value=$w2_time_hour>\n";
	print "          : \n";
	print "          <input type=\"text\" name=\"SHUTDOWN_WEEKLY_TO_MIN\" size=\"2\" maxlength=\"2\" value=$w2_time_min>\n";
	print "        </div>\n";
	print "      </td>\n";
	print "    </tr>\n";
	print "    <tr bgcolor=\"\#FFFFCC\"> \n";
	print "      <td width=\"13\%\"> \n";
	print "        <div align=\"left\"> \n";
	print "          <input type=\"radio\" name=\"SHUTDOWN_SCHEDULE_TYPE\" value=\"DAILY1\" $daily1>\n";
	print "          Daily 1</div>\n";
	print "      </td>\n";
	print "      <td width=\"44\%\"> \n";
	print "        <div align=\"center\">HH:MM \n";
	print "          <input type=\"text\" name=\"DAILY1_FROM_HOUR\" size=\"2\" maxlength=\"2\" value=$d11_hour>\n";
	print "          : \n";
	print "          <input type=\"text\" name=\"DAILY1_FROM_MIN\" size=\"2\" maxlength=\"2\" value=$d11_min>\n";
	print "        </div>\n";
	print "      </td>\n";
	print "      <td width=\"43\%\"> \n";
	print "        <div align=\"center\">HH:MM \n";
	print "          <input type=\"text\" name=\"DAILY1_TO_HOUR\" size=\"2\" maxlength=\"2\" value=$d12_hour>\n";
	print "          : \n";
	print "          <input type=\"text\" name=\"DAILY1_TO_MIN\" size=\"2\" maxlength=\"2\" value=$d12_min>\n";
	print "        </div>\n";
	print "      </td>\n";
	print "    </tr>\n";
	print "    <tr bgcolor=\"\#FFFF99\"> \n";
	print "      <td width=\"13\%\" height=\"2\">&nbsp;</td>\n";
	print "      <td width=\"44\%\" height=\"2\"> \n";
	print "        <div align=\"center\">Time</div>\n";
	print "      </td>\n";
	print "      <td width=\"43\%\" height=\"2\"> \n";
	print "        <div align=\"center\">Apply on days</div>\n";
	print "      </td>\n";
	print "    </tr>\n";
	print "    <tr bgcolor=\"\#FFFFCC\"> \n";
	print "      <td width=\"13\%\" height=\"2\"> \n";
	print "        <div align=\"left\"> \n";
	print "          <input type=\"radio\" name=\"SHUTDOWN_SCHEDULE_TYPE\" value=\"DAILY2\" $daily2>\n";
	print "          Daily 2</div>\n";
	print "      </td>\n";
	print "      <td width=\"44\%\" height=\"2\"> \n";
	print "        <div align=\"center\">HH:MM \n";
	print "          <input type=\"text\" name=\"DAILY2_FROM_HOUR\" size=\"2\" maxlength=\"2\" value=$d21_hour>\n";
	print "          : \n";
	print "          <input type=\"text\" name=\"DAILY2_FROM_MIN\" size=\"2\" maxlength=\"2\" value=$d21_min>\n";
	print "          to \n";
	print "          <input type=\"text\" name=\"DAILY2_TO_HOUR\" size=\"2\" maxlength=\"2\" value=$d22_hour>\n";
	print "          : \n";
	print "          <input type=\"text\" name=\"DAILY2_TO_MIN\" size=\"2\" maxlength=\"2\" value=$d22_min>\n";
	print "        </div>\n";
	print "      </td>\n";
	print "      <td width=\"43\%\" height=\"2\"> \n";
	print "        <div align=\"center\">Day \n";
	print "          <select name=\"DAILY2_ON_DAY\">\n";
	@day_return = &process_day($d2_day1);
	print "            <option value=\"MON\" $day_return[0]>Mon</option>\n";
	print "            <option value=\"TUE\" $day_return[1]>Tue</option>\n";
	print "            <option value=\"WED\" $day_return[2]>Wed</option>\n";
	print "            <option value=\"THU\" $day_return[3]>Thu</option>\n";
	print "            <option value=\"FRI\" $day_return[4]>Fri</option>\n";
	print "            <option value=\"SAT\" $day_return[5]>Sat</option>\n";
	print "            <option value=\"SUN\" $day_return[6]>Sun</option>\n";
	print "          </select>\n";
	print "          to \n";
	print "          <select name=\"DAILY2_TO_DAY\">\n";
	@day_return = &process_day($d2_day2);
	print "            <option value=\"MON\" $day_return[0]>Mon</option>\n";
	print "            <option value=\"TUE\" $day_return[1]>Tue</option>\n";
	print "            <option value=\"WED\" $day_return[2]>Wed</option>\n";
	print "            <option value=\"THU\" $day_return[3]>Thu</option>\n";
	print "            <option value=\"FRI\" $day_return[4]>Fri</option>\n";
	print "            <option value=\"SAT\" $day_return[5]>Sat</option>\n";
	print "            <option value=\"SUN\" $day_return[6]>Sun</option>\n";
	print "          </select>\n";
	print "        </div>\n";
	print "      </td>\n";
	print "    </tr>\n";
	print "    <tr bgcolor=\"\#FFFF99\"> \n";
	print "      <td width=\"13\%\" height=\"2\">&nbsp;</td>\n";
	print "      <td height=\"2\">&nbsp;</td>\n";
	print "      <td height=\"2\">&nbsp;</td>\n";
	print "    </tr>\n";
	print "    <tr bgcolor=\"\#FFFFCC\"> \n";
	print "      <td width=\"13\%\" height=\"2\"> \n";
	print "        <div align=\"left\"> \n";
	print "          <input type=\"radio\" name=\"SHUTDOWN_SCHEDULE_TYPE\" value=\"MANUAL\" $manual onClick=\"document.config_info_collection.submit()\">\n";
	print "          Manual</div>\n";
	print "      </td>\n";
	print "      <td colspan=\"2\" height=\"2\"> <br>\n";
	print "        <table width=\"75\%\" border=\"0\" align=\"center\" bgcolor=\"\#CCCCCC\">\n";
	print "          <tr> \n";
	print "            <td bgcolor=\"\#999999\"> \n";
	print "              <div align=\"center\"><b><font color=\"\#FFFFFF\">Shutdown Schedule</font></b></div>\n";
	print "            </td>\n";
	print "          </tr>\n";
	print "          <tr> \n";
	print "            <td bgcolor=\"\#FFFFCC\" align=\"center\">&nbsp;";
	$i = 0;
	($temp,@down_list) = @down_list;
	foreach $down_item (@down_list) {
		if(not $down_item=~/^[ ]*$/){
			print "$down_item<a href=\"$editor_script?cmd=remove&at=shutdown&item=$i\">[Remove]</a><br>";
			$i++;
		}
	}
	print "</td>\n";
	print "          </tr>\n";
	print "        </table>\n";
	print "        <br>\n";
	print "      </td>\n";
	print "    </tr>\n";
	print "</form>\n";  #End main form.
	if($manual eq 'checked'){
		print "  <form name=\"shutdown_schedule\" method=\"post\" action=\"$editor_script\">";
		print "    <tr bgcolor=\"\#FFFFCC\">\n";
		print "      <td width=\"13\%\" height=\"31\">&nbsp;</td>\n";
		print "      <td colspan=\"2\" height=\"31\">\n";
		print "        <div align=\"center\">HH : MM \n";
		print "          <input type=\"text\" name=\"SHUTDOWN_TIME_HOUR\" size=\"2\" maxlength=\"2\">\n";
		print "          : \n";
		print "          <input type=\"text\" name=\"SHUTDOWN_TIME_MIN\" size=\"2\" maxlength=\"2\">\n";
		print "          &nbsp;&nbsp;Day \n";
		print "          <select name=\"SHUTDOWN_TIME_DAY\">\n";
		print "            <option value=1 selected>1</option>\n";
		print "            <option value=2>2</option>\n";
		print "            <option value=3>3</option>\n";
		print "            <option value=4>4</option>\n";
		print "            <option value=5>5</option>\n";
		print "            <option value=6>6</option>\n";
		print "            <option value=7>7</option>\n";
		print "            <option value=8>8</option>\n";
		print "            <option value=9>9</option>\n";
		print "            <option value=10>10</option>\n";
		print "            <option value=11>11</option>\n";
		print "            <option value=12>12</option>\n";
		print "            <option value=13>13</option>\n";
		print "            <option value=14>14</option>\n";
		print "            <option value=15>15</option>\n";
		print "            <option value=16>16</option>\n";
		print "            <option value=17>17</option>\n";
		print "            <option value=18>18</option>\n";
		print "            <option value=19>19</option>\n";
		print "            <option value=20>20</option>\n";
		print "            <option value=21>21</option>\n";
		print "            <option value=22>22</option>\n";
		print "            <option value=23>23</option>\n";
		print "            <option value=24>24</option>\n";
		print "            <option value=25>25</option>\n";
		print "            <option value=26>26</option>\n";
		print "            <option value=27>27</option>\n";
		print "            <option value=28>28</option>\n";
		print "            <option value=29>29</option>\n";
		print "            <option value=30>30</option>\n";
		print "            <option value=31>31</option>\n";
		print "          </select>\n";
		print "          Month \n";
		print "          <select name=\"SHUTDOWN_TIME_MONTH\">\n";
		print "            <option value=JAN selected>January</option>\n";
		print "            <option value=FEB>Febuary</option>\n";
		print "            <option value=MAR>March</option>\n";
		print "            <option value=APR>April</option>\n";
		print "            <option value=MAY>May</option>\n";
		print "            <option value=JUN>June</option>\n";
		print "            <option value=JUL>July</option>\n";
		print "            <option value=AUG>August</option>\n";
		print "            <option value=SEP>September</option>\n";
		print "            <option value=OCT>October</option>\n";
		print "            <option value=NOV>November</option>\n";
		print "            <option value=DEC>December</option>\n";
		print "          </select><br>\n HH : MM";
		print "          <input type=\"text\" name=\"TO_TIME_HOUR\" size=\"2\" maxlength=\"2\">\n";
		print "          : \n";
		print "          <input type=\"text\" name=\"TO_TIME_MIN\" size=\"2\" maxlength=\"2\">\n";
		print "          &nbsp;&nbsp;Day \n";
		print "          <select name=\"TO_TIME_DAY\">\n";
		print "            <option value=1 selected>1</option>\n";
		print "            <option value=2>2</option>\n";
		print "            <option value=3>3</option>\n";
		print "            <option value=4>4</option>\n";
		print "            <option value=5>5</option>\n";
		print "            <option value=6>6</option>\n";
		print "            <option value=7>7</option>\n";
		print "            <option value=8>8</option>\n";
		print "            <option value=9>9</option>\n";
		print "            <option value=10>10</option>\n";
		print "            <option value=11>11</option>\n";
		print "            <option value=12>12</option>\n";
		print "            <option value=13>13</option>\n";
		print "            <option value=14>14</option>\n";
		print "            <option value=15>15</option>\n";
		print "            <option value=16>16</option>\n";
		print "            <option value=17>17</option>\n";
		print "            <option value=18>18</option>\n";
		print "            <option value=19>19</option>\n";
		print "            <option value=20>20</option>\n";
		print "            <option value=21>21</option>\n";
		print "            <option value=22>22</option>\n";
		print "            <option value=23>23</option>\n";
		print "            <option value=24>24</option>\n";
		print "            <option value=25>25</option>\n";
		print "            <option value=26>26</option>\n";
		print "            <option value=27>27</option>\n";
		print "            <option value=28>28</option>\n";
		print "            <option value=29>29</option>\n";
		print "            <option value=30>30</option>\n";
		print "            <option value=31>31</option>\n";
		print "          </select>\n";
		print "          Month \n";
		print "          <select name=\"TO_TIME_MONTH\">\n";
		print "            <option value=JAN selected>January</option>\n";
		print "            <option value=FEB>Febuary</option>\n";
		print "            <option value=MAR>March</option>\n";
		print "            <option value=APR>April</option>\n";
		print "            <option value=MAY>May</option>\n";
		print "            <option value=JUN>June</option>\n";
		print "            <option value=JUL>July</option>\n";
		print "            <option value=AUG>August</option>\n";
		print "            <option value=SEP>September</option>\n";
		print "            <option value=OCT>October</option>\n";
		print "            <option value=NOV>November</option>\n";
		print "            <option value=DEC>December</option>\n";
		print "          </select>\n ";
		print "          <input type=\"submit\" name=\"add_shutdown_schedule\" value=\"    Add    \">\n";
		print "        </div>\n";
		print "      </td>\n";
		print "    </tr>\n";
		print "	   <input type=\"hidden\" name=\"cmd\" value=\"add\">";
		print "    <input type=\"hidden\" name=\"at\" value=\"shutdown\">";
		print "  </form>";
	}
	print "  </table>\n";	
	$temp = $tokens{'UPSTEST'};
	@test_list = split(/\\/,$temp);
	print "<form name=\"test_schedule\" method=\"post\" action=\"$editor_script\">";
	print "<br>\n";
	print "  <table width=\"738\" border=\"0\" bgcolor=\"\#000000\">\n";
	print "    <tr bgcolor=\"\#006699\"> \n";
	print "      <td colspan=\"2\"><b><font color=\"\#FFFFFF\">UPS Testing</font></b></td>\n";
	print "    </tr>\n";
	print "    <tr bgcolor=\"\#FFFFCC\"> \n";
	print "      <td width=\"13\%\">&nbsp;</td>\n";
	print "      <td> <br>\n";
	print "        <table width=\"75\%\" border=\"0\" align=\"center\" bgcolor=\"\#CCCCCC\">\n";
	print "          <tr> \n";
	print "            <td bgcolor=\"\#999999\"> \n";
	print "              <div align=\"center\"><b><font color=\"\#FFFFFF\">Testing Schedule</font></b></div>\n";
	print "            </td>\n";
	print "          </tr>\n";
	print "          <tr> \n";
	print "            <td bgcolor=\"\#FFFFCC\" align=center>";
	$i = 0;
	foreach $item (@test_list){
		if(not $item=~/^[ ]*$/){
			print "$item <a href=\"$editor_script?cmd=remove&at=test&item=$i\">[Remove]</a><br>";
			$i++;
		}
	}
	print "			   </td>\n";
	print "          </tr>\n";
	print "        </table>\n";
	print "        <br>\n";
	print "      </td>\n";
	print "    </tr>\n";
	print "    <tr bgcolor=\"\#FFFFCC\"> \n";
	print "      <td width=\"13\%\">&nbsp;</td>\n";
	print "      <td> \n";
	print "        <div align=\"center\">HH:MM \n";
	print "          <input type=\"text\" name=\"TEST_TIME_HOUR\" size=\"2\" maxlength=\"2\">\n";
	print "          : \n";
	print "          <input type=\"text\" name=\"TEST_TIME_MIN\" size=\"2\" maxlength=\"2\">\n";
	print "          &nbsp;&nbsp;Day \n";
	print "          <select name=\"TEST_TIME_DAY\">\n";
	print "            <option value=1 selected>1</option>\n";
	print "            <option value=2>2</option>\n";
	print "            <option value=3>3</option>\n";
	print "            <option value=4>4</option>\n";
	print "            <option value=5>5</option>\n";
	print "            <option value=6>6</option>\n";
	print "            <option value=7>7</option>\n";
	print "            <option value=8>8</option>\n";
	print "            <option value=9>9</option>\n";
	print "            <option value=10>10</option>\n";
	print "            <option value=11>11</option>\n";
	print "            <option value=12>12</option>\n";
	print "            <option value=13>13</option>\n";
	print "            <option value=14>14</option>\n";
	print "            <option value=15>15</option>\n";
	print "            <option value=16>16</option>\n";
	print "            <option value=17>17</option>\n";
	print "            <option value=18>18</option>\n";
	print "            <option value=19>19</option>\n";
	print "            <option value=20>20</option>\n";
	print "            <option value=21>21</option>\n";
	print "            <option value=22>22</option>\n";
	print "            <option value=23>23</option>\n";
	print "            <option value=24>24</option>\n";
	print "            <option value=25>25</option>\n";
	print "            <option value=26>26</option>\n";
	print "            <option value=27>27</option>\n";
	print "            <option value=28>28</option>\n";
	print "            <option value=29>29</option>\n";
	print "            <option value=30>30</option>\n";
	print "            <option value=31>31</option>\n";
	print "          </select>\n";
	print "          Month \n";
	print "          <select name=\"TEST_TIME_MONTH\">\n";
	print "            <option value=JAN selected>January</option>\n";
	print "            <option value=FEB>Febuary</option>\n";
	print "            <option value=MAR>March</option>\n";
	print "            <option value=APR>April</option>\n";
	print "            <option value=MAY>May</option>\n";
	print "            <option value=JUN>June</option>\n";
	print "            <option value=JUL>July</option>\n";
	print "            <option value=AUG>August</option>\n";
	print "            <option value=SEP>September</option>\n";
	print "            <option value=OCT>October</option>\n";
	print "            <option value=NOV>November</option>\n";
	print "            <option value=DEC>December</option>\n";
	print "          </select>\n";
	print "          <input type=\"submit\" name=\"add_test_schedule\" value=\"    Add    \">\n";
	print "        </div>\n";
	print "        </td>\n";
	print "    </tr>\n";
	print "  </table>\n";
	print "<input type=\"hidden\" name=\"cmd\" value=\"add\">";
	print "<input type=\"hidden\" name=\"at\" value=\"test\">";
	print "</form>";
	print "<div align=\"center\"><br>\n";
	print "</div>\n";

	print "<table width=\"738\" border=\"0\">\n";
	print "  <tr>\n";
	print "    <td>\n";
	print "      <div align=\"center\">\n";
	print "        <input type=\"button\" name=\"Submit\" value=\"    Submit    \" onClick=\"document.config_info_collection.submit()\">\n";
	print "      </div>\n";
	print "    </td>\n";
	print "  </tr>\n";
	print "</table>\n";
	print "</body>\n";
	print "</html>\n";
}
